-- name: [CS] Shy Guy 64
-- description: Shy Guys! by Alestar24\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local TEXT_MOD_NAME = ""
local TEXT_MOD_VERSION = "1.5"
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local TEX_SHYMASK = get_texture_info("shymask")

local VOICETABLE_SHYGUY64 = {
    [CHAR_SOUND_ATTACKED] = 'NES-sBigJump.ogg',
    [CHAR_SOUND_DOH] = 'NES-sBump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-sBump.ogg',
    [CHAR_SOUND_DYING] = 'NES-sBump.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-sKick.ogg',
    [CHAR_SOUND_HAHA] = 'NES-s1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-s1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-s1up.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-sKick.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-sBump.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-s1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-sBump.ogg',
    [CHAR_SOUND_OOOF] = 'NES-sBump.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-sBump.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-sKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-sThwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-sThwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-s1up.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-sJump.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-s1up.ogg',
    [CHAR_SOUND_WAH2] = 'NES-sKick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-sBigJump.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-sJump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-sJump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-sBigJump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-sJump.ogg',

}






-- Load Models and Palettes
local E_MODEL_SHYGUY64ST = smlua_model_util_get_id("shyguy64st_geo")
local E_MODEL_SHYGUY64SPEAR = smlua_model_util_get_id("shyguy64spear_geo")
local E_MODEL_SHYGUY64MINIGAL = smlua_model_util_get_id("shyguy64minigal_geo")
local E_MODEL_SHYGUY64CHEF = smlua_model_util_get_id("shyguy64chef_geo")
local E_MODEL_SHYGUY64STRIKER = smlua_model_util_get_id("shyguy64striker_geo")
local E_MODEL_SHYGUY64WESTERN = smlua_model_util_get_id("shyguy64western_geo")
local E_MODEL_SHYGUY64PARTY = smlua_model_util_get_id("shyguy64party_geo")
local E_MODEL_SHYGUY64PIRATE = smlua_model_util_get_id("shyguy64pirate_geo")
local E_MODEL_SHYGUY64SNIFIT = smlua_model_util_get_id("shyguy64snifit_geo")
local E_MODEL_SHYGUY64SOMBRERO = smlua_model_util_get_id("shyguy64sombrero_geo")
local E_MODEL_SHYGUY64GHOST = smlua_model_util_get_id("shyguy64ghost_geo")
local E_MODEL_SHYGUY64MARIOBRO = smlua_model_util_get_id("shyguy64mariobro_geo")
local E_MODEL_SHYGUY64CROWN = smlua_model_util_get_id("shyguy64crown_geo")
local E_MODEL_SHYGUY64YOSHIFAN = smlua_model_util_get_id("shyguy64yoshifan_geo")
local E_MODEL_SHYGUY64TOADY = smlua_model_util_get_id("shyguy64toady_geo")
local E_MODEL_SHYGUY64YEAHTOAST = smlua_model_util_get_id("shyguy64yeahtoast_geo")
local E_MODEL_SHYGUY64CF = smlua_model_util_get_id("shyguy64cf_geo")


-- Fancy Palettes
local SHYGUY64_CF_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "000000",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_CHEF_PALETTE = {
    [PANTS]  = "202020",
    [SHIRT]  = "eeeeee",
    [GLOVES] = "ffffff",
    [SHOES]  = "ff0000",
    [HAIR]   = "ff0000",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_STRIKER_PALETTE = {
    [PANTS]  = "00eeee",
    [SHIRT]  = "ee7300",
    [GLOVES] = "ffffff",
    [SHOES]  = "000000",
    [HAIR]   = "000000",
    [SKIN]   = "fec179",
    [CAP]    = "ff9600",
}
local SHYGUY64_PARTY_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "303030",
    [SHOES]  = "6b00ff",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_PIRATE_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "000064",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_SOMBRERO_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "00ff00",
}
local SHYGUY64_MARIOBRO_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "eeeeee",
}
local SHYGUY64_CROWN_PALETTE = {
    [PANTS]  = "4700ff",
    [SHIRT]  = "ff7dc9",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "0000ff",
}
local SHYGUY64_YOSHIFAN_PALETTE = {
    [PANTS]  = "553200",
    [SHIRT]  = "00d600",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "00d600",
}
local SHYGUY64_TOADY_PALETTE = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "4c2cd3",
    [GLOVES] = "ffffff",
    [SHOES]  = "68401b",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ff0000",
}
local SHYGUY64_YEAHTOAST_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ff00ff",
}

-- Standard Palettes
local SHYGUY64_ST_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_ORANGE_PALETTE = {
    [PANTS]  = "00eeee",
    [SHIRT]  = "ee7300",
    [GLOVES] = "ffffff",
    [SHOES]  = "000000",
    [HAIR]   = "000000",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_CYAN_PALETTE = {
    [PANTS]  = "dd0000",
    [SHIRT]  = "00c0ff",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_YELLOW_PALETTE = {
    [PANTS]  = "009948",
    [SHIRT]  = "ffbe00",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_BLUE_PALETTE = {
    [PANTS]  = "930093",
    [SHIRT]  = "2d2dff",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_PINK_PALETTE = {
    [PANTS]  = "4700ff",
    [SHIRT]  = "ff7dc9",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_GREEN_PALETTE = {
    [PANTS]  = "553200",
    [SHIRT]  = "00d600",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_BLACK_PALETTE = {
    [PANTS]  = "cccccc",
    [SHIRT]  = "292929",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_WHITE_PALETTE = {
    [PANTS]  = "202020",
    [SHIRT]  = "eeeeee",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "730600",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}

-- MiniGal Palettes
local SHYGUY64_MINIGAL_PALETTE = {
    [PANTS]  = "0000ff",
    [SHIRT]  = "ff0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "01c59d",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALORANGE_PALETTE = {
    [PANTS]  = "00eeee",
    [SHIRT]  = "ee7300",
    [GLOVES] = "ffffff",
    [SHOES]  = "000000",
    [HAIR]   = "00eeee",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALCYAN_PALETTE = {
    [PANTS]  = "dd0000",
    [SHIRT]  = "00c0ff",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "ff7dc9",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALYELLOW_PALETTE = {
    [PANTS]  = "009948",
    [SHIRT]  = "ffbe00",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "292929",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALBLUE_PALETTE = {
    [PANTS]  = "930093",
    [SHIRT]  = "2d2dff",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "ffbe00",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALPINK_PALETTE = {
    [PANTS]  = "4700ff",
    [SHIRT]  = "ff7dc9",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "4700ff",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALGREEN_PALETTE = {
    [PANTS]  = "553200",
    [SHIRT]  = "00d600",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "553200",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALBLACK_PALETTE = {
    [PANTS]  = "cccccc",
    [SHIRT]  = "292929",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "ff0000",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}
local SHYGUY64_MINIGALWHITE_PALETTE = {
    [PANTS]  = "202020",
    [SHIRT]  = "eeeeee",
    [GLOVES] = "ffffff",
    [SHOES]  = "721c0e",
    [HAIR]   = "292929",
    [SKIN]   = "fec179",
    [CAP]    = "ffff00",
}

-- Character Initialize
local CT_SHYGUY64 = _G.charSelect.character_add("Shy Guy 64", "He really likes toasts (Press left or right to change outfit)", "Alestar24", {r = 200, g = 70, b = 70}, E_MODEL_SHYGUY64ST, CT_MARIO, TEX_SHYMASK)

-- Add Voices
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64ST, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64SPEAR, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64MINIGAL, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64CHEF, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64STRIKER, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64WESTERN, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64PARTY, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64PIRATE, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64SNIFIT, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64SOMBRERO, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64GHOST, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64MARIOBRO, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64CROWN, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64YOSHIFAN, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64TOADY, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64YEAHTOAST, VOICETABLE_SHYGUY64)
_G.charSelect.character_add_voice(E_MODEL_SHYGUY64CF, VOICETABLE_SHYGUY64)

-- Add ST Palettes
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_ST_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_GREEN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_BLUE_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_CYAN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_YELLOW_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_PINK_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_BLACK_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_WHITE_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64ST, SHYGUY64_ORANGE_PALETTE)

-- Add Spear Palettes
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_ST_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_GREEN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_BLUE_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_CYAN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_YELLOW_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_PINK_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_BLACK_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_WHITE_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SPEAR, SHYGUY64_ORANGE_PALETTE)

-- Add MiniGal Palette
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGAL_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALGREEN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALBLUE_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALCYAN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALYELLOW_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALPINK_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALBLACK_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALWHITE_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MINIGAL, SHYGUY64_MINIGALORANGE_PALETTE)

-- Add other Palette
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SNIFIT, SHYGUY64_ST_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SNIFIT, SHYGUY64_BLACK_PALETTE)

_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64WESTERN, SHYGUY64_ST_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64WESTERN, SHYGUY64_CYAN_PALETTE)

_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64GHOST, SHYGUY64_ST_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64GHOST, SHYGUY64_WHITE_PALETTE)

_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64SOMBRERO, SHYGUY64_SOMBRERO_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64PIRATE, SHYGUY64_PIRATE_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64YEAHTOAST, SHYGUY64_YEAHTOAST_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64TOADY, SHYGUY64_TOADY_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64YOSHIFAN, SHYGUY64_YOSHIFAN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64PARTY, SHYGUY64_PARTY_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64MARIOBRO, SHYGUY64_MARIOBRO_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64CROWN, SHYGUY64_CROWN_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64CHEF, SHYGUY64_CHEF_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64STRIKER, SHYGUY64_STRIKER_PALETTE)
_G.charSelect.character_add_palette_preset(E_MODEL_SHYGUY64CF, SHYGUY64_CF_PALETTE)

-- Update Voicelines
local character_get_voice, update_sound, update_snore = _G.charSelect.character_get_voice, _G.charSelect.voice.sound, _G.charSelect.voice.snore
local function character_sounds(m, sound)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_SHYGUY64
    then
        return update_sound(m, sound)
    end
end
local function character_snore(m)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_SHYGUY64
    then
        return update_snore(m)
    end
end

hook_event(HOOK_CHARACTER_SOUND, character_sounds)
hook_event(HOOK_MARIO_UPDATE, character_snore)

--------------------------------------------
--- Alt Costume code from Paper Partners ---
--- By Squishy ---
--------------------------------------------

local character_edit = _G.charSelect.character_edit
local character_get_current_number = _G.charSelect.character_get_current_number
local character_get_current_table = _G.charSelect.character_get_current_table
local get_options_status = _G.charSelect.get_options_status
local get_menu_color = _G.charSelect.get_menu_color
local hook_render_in_menu = _G.charSelect.hook_render_in_menu

local table_insert = table.insert
local play_sound = play_sound
local djui_hud_get_screen_width = djui_hud_get_screen_width
local djui_hud_measure_text = djui_hud_measure_text
local djui_hud_set_color = djui_hud_set_color
local djui_hud_set_resolution = djui_hud_set_resolution
local djui_hud_set_rotation = djui_hud_set_rotation
local djui_hud_set_font = djui_hud_set_font
local djui_hud_print_text = djui_hud_print_text
local djui_hud_render_rect = djui_hud_render_rect
local maxf = maxf
local math_min = math.min
local math_max = math.max
local math_sin = math.sin

local altCostumes = {
    [CT_SHYGUY64] = {
        currSkin = 1,
        {name = "Standard", model = E_MODEL_SHYGUY64ST,},
        {name = "Spear", model = E_MODEL_SHYGUY64SPEAR,},
        {name = "Minigal", model = E_MODEL_SHYGUY64MINIGAL,},
        {name = "Chef", model = E_MODEL_SHYGUY64CHEF,},
        {name = "Striker", model = E_MODEL_SHYGUY64STRIKER,},
        {name = "Western", model = E_MODEL_SHYGUY64WESTERN,},
        {name = "Party", model = E_MODEL_SHYGUY64PARTY,},
        {name = "Pirate", model = E_MODEL_SHYGUY64PIRATE,},
        {name = "Snifit", model = E_MODEL_SHYGUY64SNIFIT,},
        {name = "Sombrero", model = E_MODEL_SHYGUY64SOMBRERO,},
        {name = "Ghost", model = E_MODEL_SHYGUY64GHOST,},
        {name = "MarioBro", model = E_MODEL_SHYGUY64MARIOBRO,},
        {name = "Crown", model = E_MODEL_SHYGUY64CROWN,},
	    {name = "Yoshifan", model = E_MODEL_SHYGUY64YOSHIFAN,},
	    {name = "Toady", model = E_MODEL_SHYGUY64TOADY,},
        {name = "Community Fan", model = E_MODEL_SHYGUY64CF,},
	    {name = "YEAH TOAST", model = E_MODEL_SHYGUY64YEAHTOAST,},

    },

}

local function update_character_skin(currChar, currAlt)
    local currSkin = altCostumes[currChar][currAlt]
    if altCostumes[currChar].desc == nil then
        altCostumes[currChar].desc = character_get_current_table().description
    end
    local description = {}
    for i = 1, #altCostumes[currChar].desc do
        table_insert(description, altCostumes[currChar].desc[i])
    end
    if currSkin.name ~= "" then
        table_insert(description, "")
        table_insert(description, "Current Outfit: "..currSkin.name)
    end
    character_edit(currChar, nil, description, nil, nil, currSkin.model, nil, nil)
    local cameraToObject = gMarioStates[0].marioObj.header.gfx.cameraToObject
    play_sound(SOUND_MENU_MESSAGE_NEXT_PAGE, cameraToObject)
end

local inputLockTimer = 0
local buttonAnimTimer = 0

local MATH_DIVIDE_320 = 1/320

local latencyValueTable = {12, 6, 3}

local function hud_render()
    local width = djui_hud_get_screen_width() + 1.4
    local widthScale = maxf(width, 321.4) * MATH_DIVIDE_320
    local currChar = character_get_current_number()
    local charColors = character_get_current_table().color
    
    -- Mimick button swaying, which is missing from the paper code
    local buttonAnim = 0
    local charSelectAnim = get_options_status(_G.charSelect.optionTableRef.anims)
    if charSelectAnim > 0 then
        buttonAnimTimer = buttonAnimTimer + 1
        buttonAnim = math_sin(buttonAnimTimer * 0.05) * 2.5 + 5
    else
        buttonAnim = 10
    end

    local inputLockTimerTo = latencyValueTable[get_options_status(_G.charSelect.optionTableRef.inputLatency) + 1]

    if altCostumes[currChar] ~= nil then
        -- Render Mod Variond under CS version
        local menuColor = get_menu_color()
        djui_hud_set_color(menuColor.r, menuColor.g, menuColor.b, 255)
        djui_hud_set_font(FONT_TINY)
        local string = TEXT_MOD_NAME.." ("..TEXT_MOD_VERSION..")"
        djui_hud_print_text(string, width - 5 - djui_hud_measure_text(string)*0.5, 3, 0.5)

        ---@type Controller
        local c = _G.charSelect.controller
        local currAlts = altCostumes[currChar]

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local inputLockTimerAnim = 0

        local buttonX = 20 * widthScale + buttonAnim
        local x1 = buttonX - 4
        local x2 = x1 + 73
        local y = 97

        if charSelectAnim > 0 then
            inputLockTimerAnim = inputLockTimer/inputLockTimerTo * 3
            x1 = x1 + math_min(inputLockTimerAnim, 0)
            x2 = x2 + math_max(inputLockTimerAnim, 0)
        end
        -- Left Arrow
        if currAlts.currSkin > 1 then
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x1, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x1 + 2.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                currAlts.currSkin = math_max(currAlts.currSkin - 1, 1)
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = -inputLockTimerTo
            end
        end
        -- Right Arrow
        if currAlts.currSkin < #currAlts then
            -- Changed arrows to mimick the ones seen in the options menu
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x2, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x2 - 3.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX + 69, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                currAlts.currSkin = currAlts.currSkin + 1
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = inputLockTimerTo
            end
        end
        -- use an input lock to prevent cycling too fast
        if inputLockTimer > 0 then
            inputLockTimer = inputLockTimer - 1
        elseif inputLockTimer < 0 then
            inputLockTimer = inputLockTimer + 1
        end
    end
end

hook_render_in_menu(hud_render)
